package
{
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import Page;
	import Sign;
	import Vera;

	public class Eval extends Sprite
	{
		private var l:XMLList; // xml du qcm
		private var q:Array = new Array(); // numeros de questions tirees
		private var c:Array = new Array(); // numero des reponses correctes
		private var d:Array = new Array(); // numero des reponses cochees
		private var n:int = 0; // question en cours
		
		public function Eval():void
		{
			var u:URLRequest = new URLRequest('./assets/eval.xml');
			var w:URLLoader = new URLLoader(u);
			w.addEventListener(Event.COMPLETE, parseur);
			
			// lecture du xml
			function parseur(e:Event):void
			{
				l = XML(e.target.data).children();
				var t:Array = new Array();
				for(var i:int = 0; i < l.length(); i++)
				{
					t[i] = i;
				}
				
				// selection et enregistrement de 3 question
				var r:int = Math.floor(Math.random()*l.length());
				q[0] = t[r];
				c[0] = String(l[q[0]].choix.reponse.(@correct == "true"));
				t.splice(r, 1);
				r = Math.floor(Math.random()*(l.length()-1));
				q[1] = t[r];
				c[1] = String(l[q[1]].choix.reponse.(@correct == "true"));
				t.splice(r, 1);
				r = Math.floor(Math.random()*(l.length()-2));
				q[2] = t[r];
				c[2] = String(l[q[2]].choix.reponse.(@correct == "true"));
				question();
			}
		}
		
		// affichage d une question
		public function question():void
		{
			// vidage de l affichage
			var m:int = this.numChildren;
			for(var j:int = 0; j < m; j++)
			{
				this.removeChildAt(0);
			}
			// affichage de l enonce
			var t:Vera = new Vera(l[q[n]].enonce);
			this.addChild(t);
			// affichage de la courbe
			var s:Sign = new Sign(200, 140, String(l[q[n]].courbe.@forme), l[q[n]].courbe.@frequence, l[q[n]].courbe.@amplitude, l[q[n]].courbe.@offset, l[q[n]].courbe.@rapport, toBoolean(l[q[n]].courbe.@moyenne), toBoolean(l[q[n]].courbe.@remplissage), l[q[n]].courbe.@legende);
			s.y = 20;
			this.addChild(s);
			// affichage des reponses
			var r1:Sprite = new Sprite(); // case a cocher
			r1.x = 240;
			r1.y = 68;
			r1.graphics.lineStyle(2, 0x00bb99);
			r1.graphics.beginFill(0xFFFFFF);
			r1.graphics.drawCircle(0, 0, 5);
			r1.name = 'r1';
			r1.buttonMode = true;
			this.addChild(r1);
			var t1:Vera = new Vera(l[q[n]].choix.reponse[0]); // label
			t1.x = 20;
			t1.y = -10;
			r1.addChild(t1);
			r1.addEventListener(MouseEvent.CLICK, selected); // ecouteur
			var r2:Sprite = new Sprite(); // case a cocher
			r2.x = 240;
			r2.y = 88;
			r2.graphics.lineStyle(2, 0x00bb99);
			r2.graphics.beginFill(0xFFFFFF);
			r2.graphics.drawCircle(0, 0, 5);
			r2.name = 'r2';
			r2.buttonMode = true;
			this.addChild(r2);
			var t2:Vera = new Vera(l[q[n]].choix.reponse[1]); // label
			t2.x = 20;
			t2.y = -10;
			r2.addChild(t2);
			r2.addEventListener(MouseEvent.CLICK, selected); // ecouteur
			var r3:Sprite = new Sprite(); // case a cocher
			r3.x = 240;
			r3.y = 108;
			r3.graphics.lineStyle(2, 0x00bb99);
			r3.graphics.beginFill(0xFFFFFF);
			r3.graphics.drawCircle(0, 0, 5);
			r3.name = 'r3';
			r3.buttonMode = true;
			this.addChild(r3);
			var t3:Vera = new Vera(l[q[n]].choix.reponse[2]); // label
			t3.x = 20;
			t3.y = -10;
			r3.addChild(t3);
			r3.addEventListener(MouseEvent.CLICK, selected); // ecouteur
			
			// gestion des boutons suivant/correction
			if(n < 2)
			{
				var b:Vera = new Vera('Question suivante >', 200, 'l', 12, 'vert');
				b.x = 300;
				b.y = 150;
				this.addChild(b);
				b.buttonMode = true;
				b.addEventListener(MouseEvent.CLICK, suivante);
			}
			else
			{
				var v:Vera = new Vera('Vérifier les réponses >>', 200, 'l', 12, 'vert');
				v.x = 280;
				v.y = 150;
				this.addChild(v);
				v.buttonMode = true;
				v.addEventListener(MouseEvent.CLICK, verif);
			}
		}
		
		// slection d un item
		public function selected(e:MouseEvent):void
		{
			// reinitialisation de toutes les case
			Sprite(this.getChildAt(2)).graphics.clear();
			Sprite(this.getChildAt(2)).graphics.lineStyle(2, 0x00bb99);
			Sprite(this.getChildAt(2)).graphics.beginFill(0xFFFFFF);
			Sprite(this.getChildAt(2)).graphics.drawCircle(0, 0, 5);
			Sprite(this.getChildAt(3)).graphics.clear();
			Sprite(this.getChildAt(3)).graphics.lineStyle(2, 0x00bb99);
			Sprite(this.getChildAt(3)).graphics.beginFill(0xFFFFFF);
			Sprite(this.getChildAt(3)).graphics.drawCircle(0, 0, 5);
			Sprite(this.getChildAt(4)).graphics.clear();
			Sprite(this.getChildAt(4)).graphics.lineStyle(2, 0x00bb99);
			Sprite(this.getChildAt(4)).graphics.beginFill(0xFFFFFF);
			Sprite(this.getChildAt(4)).graphics.drawCircle(0, 0, 5);
			
			// cocher la case selectionnee
			Sprite(e.currentTarget).graphics.endFill();
			Sprite(e.currentTarget).graphics.lineStyle(2, 0x000000);
			Sprite(e.currentTarget).graphics.moveTo(-5, -4);
			Sprite(e.currentTarget).graphics.lineTo(0, 2);
			Sprite(e.currentTarget).graphics.lineTo(7, -3);
			
			// enregistrement de la reponse
			d[n] = String(l[q[n]].choix.reponse[parseInt(String(e.target.name).substr(1, 1))-1]);
		}
		
		// affichage de la question suivante
		public function suivante(e:MouseEvent):void
		{
			n++;
			question();
		}
		
		// correction du qcm
		public function verif(e:MouseEvent):void
		{
			// vidage de l affichage
			var m:int = this.numChildren;
			for(var j:int = 0; j < m; j++)
			{
				this.removeChildAt(0);
			}
			
			// affichage des correction
			for(j = 0; j < 3; j++)
			{
				var s:Sign = new Sign(120, 100, String(l[q[j]].courbe.@forme), l[q[j]].courbe.@frequence, l[q[j]].courbe.@amplitude, l[q[j]].courbe.@offset, l[q[j]].courbe.@rapport, toBoolean(l[q[j]].courbe.@moyenne), toBoolean(l[q[j]].courbe.@remplissage), l[q[j]].courbe.@legende);
				s.y = j*110;
				this.addChild(s);
				
				if(c[j] == d[j]) // reponse correcte
				{
					var c1:Vera = new Vera('Votre réponse, ' + d[j] + ', est correcte.');
					c1.x = 140;
					c1.y = j*110 + 40;
					this.addChild(c1);
				}
				
				else // reponse erronee
				{
					if(d[j] == undefined) // pas de reponse
					{
						var c2:Vera = new Vera('Vous n\'avez pas répondu à la question.');
						c2.x = 140;
						c2.y = j*110;
						this.addChild(c2);
					}
					else // mauvaise reponse
					{
						var c3:Vera = new Vera('Votre réponse, ' + d[j] + ', est erronée.');
						c3.x = 140;
						c3.y = j*110;
						this.addChild(c3);
					}
					// affichage de la correctiob
					var c4:Vera = new Vera(l[q[j]].correction + ' Pensez à revoir le cours sur ' + l[q[j]].cours + '.', 280);
					c4.x = 140;
					c4.y = j*110 + 18;
					this.addChild(c4);
					// affichage de la reponse correcte
					var c5:Vera = new Vera('Ici, on trouve ' + l[q[j]].choix.reponse.(@correct == "true"));
					c5.x = 140;
					c5.y = c4.y + c4.height + 2;
					this.addChild(c5);
				}
			}
			
			// bouton pour effectuer une nouvelle evaluation
			var rep:Vera = new Vera('Effectuer une nouvelle évaluation', 400, 'c', 12, 'vert');
			rep.x = 130;
			rep.y = 320;
			rep.buttonMode = true;
			this.addChild(rep);
			rep.addEventListener(MouseEvent.MOUSE_DOWN, replay);
		}
		
		// appel d une nouvelle evaluation
		public function replay(e:MouseEvent):void
		{
			// le bouton fait appel a la navigation de l objet parent de type Page
			Page(this.parent).navig('e1');
		}
		
		// utilitaire convertissant un string true/false en booleen
		public function toBoolean(val:String):Boolean  
		{  
			if (val == "true") { return true; } else { return false; }  
		}
	}
}