package
{

	import flash.display.Graphics;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import Page;
	import Vera;
	
	public class Menu extends Sprite
	{		
		private var p:Page = new Page(); // classe gerant le contenu
		private var c:Vera = new Vera('Cours', 100, 'l', 12, 'vert');
		private var c1:Vera = new Vera('Types de signaux', 125, 'l', 12, 'vert');
		private var c2:Vera = new Vera('Fréquence', 100, 'l', 12, 'vert');
		private var c3:Vera = new Vera('Amplitude', 100, 'l', 12, 'vert');
		private var c4:Vera = new Vera('Valeur moyenne', 125, 'l', 12, 'vert');
		private var c5:Vera = new Vera('Rapport cyclique', 125, 'l', 12, 'vert');
		private var m:Vera = new Vera('Manipulation', 100, 'l', 12, 'vert');
		private var e:Vera = new Vera('Evaluation', 100, 'l', 12, 'vert');
		private var e1:Vera = new Vera('QCM', 100, 'l', 12, 'vert');
		private var e2:Vera = new Vera('Pratique', 100, 'l', 12, 'vert');
		private var s:Sprite = new Sprite();
		
		public function Menu():void
		{	
			// dessin du cadre
			var back:Sprite = new Sprite();
			back.graphics.lineStyle(3, 0xbbdddd);
			back.graphics.beginFill(0xFFFFFF);
			back.graphics.drawRoundRect(5, 5, 160, 200, 10, 10);
			this.addChild(back);
			
			// initialisation des boutons
			
			c.addEventListener(MouseEvent.CLICK, acces);
			c.buttonMode = true;
			c.x = 15;
			c.y = 15;
			c.name = 'c';
			this.addChild(c);
			
			c1.x = 30;
			c1.y = 30;
			c1.name = 'c1';
			this.addChild(c1);
			
			c2.x = 30;
			c2.y = 45;
			c2.name = 'c2';
			this.addChild(c2);
			
			c3.x = 30;
			c3.y = 60;
			c3.name = 'c3';
			this.addChild(c3);
			
			c4.x = 30;
			c4.y = 75;
			c4.name = 'c4';
			this.addChild(c4);
			
			c5.x = 30;
			c5.y = 90;
			c5.name = 'c5';
			this.addChild(c5);
			
			m.x = 15;
			m.y = 110;
			m.name = 'm';
			this.addChild(m);
			
			e.addEventListener(MouseEvent.CLICK, acces);
			e.buttonMode = true;
			e.x = 15;
			e.y = 130;
			e.name = 'e';
			this.addChild(e);
			
			e1.x = 30;
			e1.y = 145;
			e1.name = 'e1';
			this.addChild(e1);
			
			e2.x = 30;
			e2.y = 160;
			e2.name = 'e2';
			this.addChild(e2);
			
			this.addChild(p);
			
			this.refresh('');
		}
		
		// action du menu
		public function acces(e:MouseEvent):void
		{
			var n:String = e.currentTarget.name;
			// gestion des redirections vers les premiers chapitres
			if(n == 'c')
			{
				n = 'c1';
			}
			if(n == 'e')
			{
				n = 'e1';
			}
			this.refresh(n); // mise a jour du menu
			p.navig(n); // appel du contenu
		}
		
		// mise a jour du menu (ecouteurs et couleurs)
		public function refresh(n:String):void
		{
			// gestion du decalage du menu sur la page d accueil
			this.y = 100;
			if(n == '')
			{
				this.x = 240;
			}
			else
			{
				this.x = 10;
			}
			
			// mise a jour des boutons
			
			if(n != 'c1')
			{
				c1.setColor('vert');
				c1.addEventListener(MouseEvent.CLICK, acces);
				c1.buttonMode = true;
			}
			else
			{
				c1.setColor('black');
				c1.removeEventListener(MouseEvent.CLICK, acces);
				c1.buttonMode = false;
			}
			
			if(n != 'c2')
			{
				c2.setColor('vert');
				c2.addEventListener(MouseEvent.CLICK, acces);
				c2.buttonMode = true;
			}
			else
			{
				c2.setColor('black');
				c2.removeEventListener(MouseEvent.CLICK, acces);
				c2.buttonMode = false;
			}
			
			if(n != 'c3')
			{
				c3.setColor('vert');
				c3.addEventListener(MouseEvent.CLICK, acces);
				c3.buttonMode = true;
			}
			else
			{
				c3.setColor('black');
				c3.removeEventListener(MouseEvent.CLICK, acces);
				c3.buttonMode = false;
			}
			
			if(n != 'c4')
			{
				c4.setColor('vert');
				c4.addEventListener(MouseEvent.CLICK, acces);
				c4.buttonMode = true;
			}
			else
			{
				c4.setColor('black');
				c4.removeEventListener(MouseEvent.CLICK, acces);
				c4.buttonMode = false;
			}
			
			if(n != 'c5')
			{
				c5.setColor('vert');
				c5.addEventListener(MouseEvent.CLICK, acces);
				c5.buttonMode = true;
			}
			else
			{
				c5.setColor('black');
				c5.removeEventListener(MouseEvent.CLICK, acces);
				c5.buttonMode = false;
			}
			
			if(n != 'm')
			{
				m.setColor('vert');
				m.addEventListener(MouseEvent.CLICK, acces);
				m.buttonMode = true;
			}
			else
			{
				m.setColor('black');
				m.removeEventListener(MouseEvent.CLICK, acces);
				m.buttonMode = false;
			}
			
			if(n != 'e1')
			{
				e1.setColor('vert');
				e1.addEventListener(MouseEvent.CLICK, acces);
				e1.buttonMode = true;
			}
			else
			{
				e1.setColor('black');
				e1.removeEventListener(MouseEvent.CLICK, acces);
				e1.buttonMode = false;
			}
			
			if(n != 'e2')
			{
				e2.setColor('vert');
				e2.addEventListener(MouseEvent.CLICK, acces);
				e2.buttonMode = true;
			}
			else
			{
				e2.setColor('black');
				e2.removeEventListener(MouseEvent.CLICK, acces);
				e2.buttonMode = false;
			}
			
			// affichage des logos sur la page d accueil
			if(n == '')
			{
				s.name = 'logos';
				s.y = 200;
				s.x = -100;
				this.addChild(s);
				var t:URLRequest = new URLRequest('./assets/img/logo_ufc.png');
				var k:Loader = new Loader();
				k.y = 20;
				k.x = 0;
				k.load(t);
				k.name ='logo_ufc';
				s.addChild(k);
				var u:URLRequest = new URLRequest('./assets/img/logo_psm.png');
				var l:Loader = new Loader();
				l.y = 40;
				l.x = 130;
				l.load(u);
				l.name ='logo_psm';
				s.addChild(l);
				var v:URLRequest = new URLRequest('./assets/img/logo_viette.png');
				var m:Loader = new Loader();
				m.y = 0;
				m.x = 250;
				m.load(v);
				k.name ='logo_viette';
				s.addChild(m);
			}
			// suppression des logos si besoin est
			else
			{
				if(this.getChildByName('logos') != null)
				{
					this.removeChild(s);
				}
			}
		}
	}
}