package
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.Font;
	
	public class Vera extends Sprite
	{
		[Embed(source='./assets/DejaVuLGCSans.ttf', fontName='VeraSans', mimeType='application/x-font-truetype', unicodeRange='U+0020-U+03FF' )]
		public var VeraSans:Class; // necessaire a l import de la police
		private var format:TextFormat = new TextFormat(); // fort du texte
		private var field:TextField = new TextField(); // champ de texte
		public function Vera(texte:String, largeur:int = 420, align:String = 'l', taille:int = 12, couleur:String = ''):void
		{
			Font.registerFont(VeraSans);
			
			format.font = 'VeraSans';
			format.size = taille;
			format.bold = false;
			if(couleur == 'vert')
			{
				format.color = 0x00bb99;
			}
			else
			{
				format.color = 0x000000;
			}
			
			field.autoSize = TextFieldAutoSize.LEFT;
			field.width = largeur;
			if(align == 'l')
			{
				field.autoSize = TextFieldAutoSize.LEFT;
				field.wordWrap = true;
			}
			else if(align == 'c')
			{
				field.autoSize = TextFieldAutoSize.CENTER;
			}
			field.embedFonts = true;
			field.text = texte;
			field.setTextFormat(format);
			this.addChild(field);
			
			this.mouseChildren = false;
		}
		
		// modifier le texte
		public function setTexte(txt:String):void
		{
			field.text = txt;
			field.setTextFormat(format);
		}
		
		// modifier la couleur
		public function setColor(couleur:String):void
		{
			if(couleur == 'vert')
			{
				field.textColor = 0x00bb99;
			}
			else
			{
				field.textColor = 0x000000;
			}
		}
	}
}